import numpy as np
import sys
import os
import gc
from collections import Counter

GRAPHSIZE = 8000 # initial number of cities
number = 100 # number of runs to process
rseed = 1 # seed
BETA = 0.4
paretoC = 1

# give location from bash
loc = sys.argv[1]

# define array
hopdist = np.array([0.,0.])

degrees = Counter()

num1 = 0
# start collecting results
for i in range(number):
	stinfo = os.stat(loc+str(GRAPHSIZE)+"_hopVdist_"+str(BETA).replace(".","p")+"_"+str(paretoC).replace('.','p')+"_"+str(i*rseed)+".dat")
	if stinfo.st_size != 0:
		hopdist = np.row_stack((hopdist, np.loadtxt(loc+str(GRAPHSIZE)+"_hopVdist_"+str(BETA).replace(".","p")+"_"+str(paretoC).replace('.','p')+"_"+str(i*rseed)+".dat" ,delimiter=' ',dtype=float)))

		degree = np.loadtxt(loc+str(GRAPHSIZE)+"_degree_"+str(BETA).replace(".","p")+"_"+str(paretoC).replace('.','p')+"_"+str(i*rseed)+".dat", delimiter=' ',dtype=int)
		degrees += Counter(dict(zip(degree[:,0], degree[:,1])))
	else:
		num1+=1

dgs = np.array(degrees.items())

hops = hopdist[1:,1]
distances = hopdist[1:,0]

dists = np.linspace(min(distances),max(distances), 15)

# averaging results
tims = np.zeros(len(dists))
for i in xrange(len(dists)-1):
	if len(hops[np.where((distances>dists[i])*(distances<dists[i+1]))]) > 0:
		tims[i] = np.mean(hops[np.where((distances>dists[i])*(distances<dists[i+1]))])
	else:
		tims[i] = -1000

hopdist = np.column_stack(((0.5*dists[1:]+0.5*dists[:-1])[np.where(tims[:-1]!=-1000)], tims[:-1][np.where(tims[:-1]!=-1000)] ))

# saving data to plot
np.savetxt(loc+str(GRAPHSIZE)+'_degreesBETA'+str(BETA).replace('.','p')+"_paretoC"+str(paretoC).replace('.','p')+"_avgOn"+str(number)+"_Seed"+str(rseed)+'.dat', dgs, fmt="%d", delimiter = ' ')
np.savetxt(loc+str(GRAPHSIZE)+'_hopANDdistBETA'+str(BETA).replace('.','p')+"_paretoC"+str(paretoC).replace('.','p')+"_avgOn"+str(number)+"_Seed"+str(rseed)+'.dat', hopdist, delimiter = ' ', fmt='%f')

gc.collect()

	